function[Mat1, Mat2, Mat3, Mat4] = run(Mat1, Mat2, Mat3, Mat4, T)

MatParts = Mat1 + Mat2 + Mat3 + Mat4; % Matrice contenant le nombre de particules à chaque case
imagesc(MatParts) % Pour afficher l'état initial si T = 0
colorbar

for t = 1 : T
    [Mat1, Mat3, Mat2Temp, Mat4Temp] = hpp1(Mat1, Mat2, Mat3, Mat4); % Exécute l'automate (vertical)
    [Mat1, Mat2, Mat3, Mat4] = hpp2(Mat1, Mat2, Mat3, Mat4, Mat2Temp, Mat4Temp); % Exécute l'automate (horizontal)
    
    MatParts = Mat1 + Mat2 + Mat3 + Mat4;
    imagesc(MatParts)
    colorbar
    Nparts = sum(sum(MatParts));
    sprintf('Nombre de particules à la période %d : %d', t, Nparts)
    pause on
        pause(0.02)
    pause off
end