function[FOut, rho, ux, uy] = lattboltz(fIn, tau) % Lattice Boltzmann

[m,n,~] = size(fIn);
c = [[0,0] ; [0,1] ; [-1,0] ; [0,-1]; [1,0]; [-1,1]; [-1,-1]; [1,-1]; [1,1]];
t = [4/9 1/9 1/9 1/9 1/9 1/36 1/36 1/36 1/36];

FOut = zeros(m,n,9); rho = zeros(m,n);
ux = zeros(m,n); uy = zeros(m,n); fEq = zeros(m,n,9);

%tic
for i = 1 : 9 % Calculer les densités
    rho = rho + fIn(:,:,i);
end
%dens = toc

rho(:,1) = 1; rho(:,n) = 1; rho(m,:) = 1; rho(1,2:n-1) = 1; % rho_0 = 1

%tic
for k = 1 : n % Calculer les vitesses
    for j = 1 : m
        for i = 1 : 9
            ux(j,k) = ux(j,k) + (c(i,2)*fIn(j,k,i));
            uy(j,k) = uy(j,k) + (c(i,1)*fIn(j,k,i));
        end
        ux(j,k) = ux(j,k)/rho(j,k);
        uy(j,k) = uy(j,k)/rho(j,k);
    end
end
%vel = toc

% Gauche     Droite       Bas          Haut
uy(:,1) = 0; uy(:,n) = 0; uy(m,2:n-1) = 0; uy(1,2:n-1) = 0;
ux(:,1) = 0; ux(:,n) = 0; ux(m,2:n-1) = 0; ux(1,2:n-1) = 0.1;

%tic
for j = 1 : m
    for k = 1 : n % Calculer les fEq  
        u2 = ux(j,k)*ux(j,k)+uy(j,k)*uy(j,k);
        for i = 1 : 9
            uc = ux(j,k)*c(i,2)+uy(j,k)*c(i,1);
            fEq(j,k,i) = rho(j,k)*t(i)*(1 + uc*3 + uc^2*4.5 - u2*1.5);
        end
    end
end
%feq = toc

%tic 
for i = 1 : 9 % Calculer tous les f_i out
    FOut(:,:,i) = (1 - 1/tau)*fIn(:,:,i) + (1/tau)*fEq(:,:,i);
    FOut(:,:,i) = circshift(FOut(:,:,i), c(i,:));
end
%   stream = toc